/*Newton Raphson Method*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>

float score(float n_o, float n_a, float n_b, float n_ab, float p, float q);
float info11(float n_o, float n_a, float n_b, float n_ab, float p, float q);
float info21(float n_o, float n_a, float n_b, float n_ab, float p, float q);



int main(void)
{
  int i;
  float  n_a, n_b, n_ab, n_o, acc, p, q,
  a, b , c, s1, s2,
  h, k, dm;
  /*Data Entry*/
  printf("Enter the Frequencies...\n\n");
  printf("Enter the number of persons with Phenotype O: ");
  scanf("%f",&n_o);
  printf("Enter the number of persons with Phenotype A: ");
  scanf("%f",&n_a);
  printf("Enter the number of persons with Phenotype AB: ");
  scanf("%f",&n_b);
  printf("Enter the number of persons with Phenotype AB: ");
  scanf("%f",&n_ab);

  /*Initialization*/

  p = pow((n_a + n_o)/(n_a + n_b + n_o + n_ab),0.5) - pow(n_o/(n_a + n_b + n_o + n_ab),0.5);
  q = pow((n_b + n_o)/(n_a + n_b + n_o + n_ab),0.5) - pow(n_o/(n_a + n_b + n_o + n_ab),0.5);

  for(i = 1; i <= 10; i++){
    a = info11(n_o, n_a, n_b, n_ab, p, q);
    b = info11(n_o, n_b, n_a, n_ab, q, p);
    c = info21(n_o, n_a, n_b, n_ab, p, q);
    s1 = score(n_o, n_a, n_b, n_ab, p, q);
    s2 = score(n_o, n_b, n_a, n_ab, q, p);
    dm = a * b - c * c;
    h = -s1 * b + s2 * c;
    k =  s1 * c - s2 * a;
    p = p + h/dm;
    q = q + k/dm;
    printf("%f, %f\n",p,q);
  }
  return 0;
}




float score(float n_o, float n_a, float n_b, float n_ab, float p, float q)
{
 
  return (-2 * n_o/(1 - p - q) + n_a * (1/p - 1/(2 - p - 2 * q)) - n_b * (2/(2 - q - 2 * p)) + n_ab/p);
 
}


float info11(float n_o, float n_a, float n_b, float n_ab, float p, float q)
{
return (-2* n_o/pow((1 - p -q),2.0) - n_a * (1/(p *p) + 1/pow((2 - p - 2 * q),2.0)) - n_b * 2/pow((2 - q - 2 * p),2.0) - n_ab/(p*p));
}


float info21(float n_o, float n_a, float n_b, float n_ab, float p, float q)
{
  return (-2 * n_o/pow((1 - p -q),2.0) - n_a * 2/pow((2 - p - 2 * q),2) - n_b * 4/pow((2 - q - 2 * p),2.0));
}
